#ifndef	RTL_NIC_H
#define	RTL_NIC_H

#include "common/rtl_types.h"

#ifdef CONFIG_RTL8196_RTL8366
	#if 1
		#define	RTL_WANPORT_MASK		0x1c1
		#define	RTL_LANPORT_MASK		0x1c1
	#else
		#define	RTL_WANPORT_MASK		0x1
		#define	RTL_LANPORT_MASK		0x1
	#endif
	#define RTL8366RB_GMIIPORT			0x20
	#define RTL8366RB_LANPORT			0xCf
	#define RTL8366RB_WANPORT			0x10
#else
	#ifdef CONFIG_RTL8186_KB_N
		#define	RTL_WANPORT_MASK		0x10
		#define	RTL_LANPORT_MASK		0x1cf
	#else
		#if defined(CONFIG_RTL865X_EXTPORT)
			#define	RTL_WANPORT_MASK	0x01
			#define	RTL_LANPORT_MASK	0x1de
		#else
			#if defined(_WAN_IS_PORT4)
				#define	RTL_WANPORT_MASK	0x10	//	port4
				#define	RTL_LANPORT_MASK	0x10f	//	port0/1/2/3/cpu port(port 8)
				#define	AMIT_VLAN_MASK_1	0x107	//	port0/1/2/cpu port(port 8)
				#define	AMIT_VLAN_MASK_2	0x103	//	port0/1/cpu port(port 8)
			#else
				#define	RTL_WANPORT_MASK	0x01	//	port0
				#define	RTL_LANPORT_MASK	0x11e	//	port1/2/3/4/cpu port(port 8) 
				#define	AMIT_VLAN_MASK_1	0x11c	//	port0/1/2/cpu port(port 8)
				#define	AMIT_VLAN_MASK_2	0x118	//	port0/1/cpu port(port 8)
			#endif
		#endif

		#if defined(CONFIG_RTK_VLAN_SUPPORT)
			#if defined(CONFIG_TRENDCHIP_ADSL_VLAN)	//	keep port1~4 in the same group.
				#define	RTL_LANPORT_MASK_1	RTL_LANPORT_MASK	//port 1
				#define	RTL_LANPORT_MASK_2	RTL_LANPORT_MASK	//port 2
				#define RTL_LANPORT_MASK_3	RTL_LANPORT_MASK	//port 3
				#define RTL_LANPORT_MASK_4	RTL_LANPORT_MASK	//port 4
			#else
				#define	RTL_LANPORT_MASK_1	0x2		//port 1
				#define	RTL_LANPORT_MASK_2	0x4		//port 2
				#define	RTL_LANPORT_MASK_3	0x8		//port 3
				#define	RTL_LANPORT_MASK_4	0x10	//port 4
			#endif
		#endif
	#endif
#endif

#define	RTL_WANVLANID		8
#define	RTL_LANVLANID		9

#if defined(CONFIG_RTK_VLAN_SUPPORT)
#define	RTL_LANVLANID_2		10
#define	RTL_LANVLANID_3		11
#define	RTL_LANVLANID_4		12
#endif

#define	RTL_PPTPL2TP_VLANID	999

#ifdef CONFIG_RTL865X_LAYERED_DRIVER
#include "common/rtl865x_netif.h"

struct rtl865x_vlanConfig {
	uint8 			ifname[IFNAMSIZ];
	uint8			isWan;
	uint16			if_type;
	uint16			vid;
	uint16			fid;
	uint32			memPort;
	uint32			untagSet;
	uint32			mtu;
	ether_addr_t		mac;
	uint8			is_slave;
};
#define RTL865X_CONFIG_END					{ "", 0, 0, 0, 0, 0, 0, 0, {{0}}, 0 }

#define GATEWAY_MODE				0
#define BRIDGE_MODE				1
#define WISP_MODE					2
#define MULTIPLE_VLAN_BRIDGE_MODE 3
#define MULTIPLE_VLAN_WISP_MODE 4
#define LANWAN_BRIDGE_MODE		5

#define VLAN_BRIDGE_MODE		6
#define VLAN_BRIDGE_MODE_1		7
#define VLAN_BRIDGE_MODE_2      8
#define VLAN_BRIDGE_MODE_3      9

#define CONFIG_CHECK(expr) do {\
	if(((int32)expr)!=SUCCESS){\
		rtlglue_printf("Error >>> %s:%d failed !\n", __FUNCTION__,__LINE__);\
			return FAILED;\
	}\
}while(0)

#define INIT_CHECK(expr) do {\
	if(((int32)expr)!=SUCCESS){\
		rtlglue_printf("Error >>> %s:%d failed !\n", __FUNCTION__,__LINE__);\
			return FAILED;\
	}\
}while(0)
#endif

#ifdef CONFIG_RTL8186_GR
extern int __init rtl8651_customPassthru_init(void);
int32 rtl8651_initStormCtrl(void);
#endif

#endif
