#include <linux/module.h>
#include <linux/proc_fs.h>
#include <linux/types.h>
#include <linux/errno.h>
#include <linux/sched.h>
#include <linux/kernel.h>
#include <linux/kernel_stat.h>
#include <linux/init.h>
#include <linux/module.h>
#include <linux/slab.h>
#include <asm/uaccess.h>
//#include <linux/brlock.h>
#include <linux/net.h>
#include <linux/socket.h>

#include <linux/netdevice.h>
#include <linux/etherdevice.h>
#include <linux/string.h>
#include <net/ip.h>
#include <net/protocol.h>
#include <net/route.h>
#include <net/sock.h>
#include <net/arp.h>
#include <net/raw.h>
#include <net/checksum.h>
#include <linux/netfilter.h>
#include <linux/netfilter_ipv4.h>
#include <linux/netlink.h>

#include <linux/in.h>
#include <linux/udp.h>
#include <linux/if_tunnel.h>
#include <linux/if_ether.h>
#include <asm-mips/atomic.h>
#include "fastpath_core.h"

#ifdef FAST_L2TP
#include "fast_l2tp_core.h"
#endif

/*common*/
#ifdef CONFIG_RTL865X_LAYERED_DRIVER
#include <common/rtl865x_vlan.h>
#include <common/rtl865x_netif.h>
#include <common/rtl865x_netif_local.h>
#else
#include <common/rtl865x_common.h>
#include <common/rtl865x_common_local.h>
#endif

#ifdef CONFIG_NET_QOS
extern int gQosEnabled;
#endif

#if defined(FAST_L2TP)

static struct l2tp_info l2tpInfo={NULL};
uint32 state;
#define L2TP_INITED 0
#define L2TP_REPLY_RECEIVED 1
#define L2TP_CONNECTED 2


void l2tp_tx_id(struct sk_buff *skb)
{
        __u16 *p_id;
        __u16 MessageType;
	struct iphdr *iph;

	iph = skb->nh.iph;
        struct udphdr *hdr = (struct udphdr *)((u_int32_t *)iph + iph->ihl);
        struct l2tp_header *l2tp_ptr = (struct l2tp_header *)((u_int8_t *)hdr+8);
        if(hdr->source==1701 && hdr->dest==1701 && (l2tp_ptr->ver & 0x8000)==control_message)
          {
	  	if((l2tp_ptr->ver & 0x4000)==0)
	    		p_id=(__u16 *)((u_int8_t *)(&l2tp_ptr->ver)+2);
	  	else
	    		p_id=&l2tp_ptr->tid;

          	MessageType=*(p_id+7);
          	if(MessageType==stop_control && l2tpInfo.tid==*p_id)
	  	{
	  		memset(&l2tpInfo, '\0', sizeof(l2tpInfo));
			DEBUGP("FAST-L2TP, stop control, dev->name=%s\n", skb->dev->name);
			rtl865x_setNetifType("ppp0", IF_PPPOE);
			state = L2TP_INITED;
	  	}

          	if(MessageType==call_reply)
	  	{
	  		/*hyking:
	  		*bug fix:l2tp wantype,l2tp pass thru
	  		*/
	  		/*log mac information when from wan interface, not from br0 or to br0*/
	  		if(state < L2TP_REPLY_RECEIVED && memcmp(skb->dev->name,"eth1",4) == 0)
	  		{
				l2tpInfo.wan_dev = skb->dev;
		      		memcpy(&l2tpInfo.mac_header[0], skb->data-ETH_HLEN+ETH_ALEN, ETH_ALEN); // da of tx pkt
				memcpy(&l2tpInfo.mac_header[ETH_ALEN], skb->data-ETH_HLEN, ETH_ALEN); // sa of tx pkt
				memcpy(&l2tpInfo.mac_header[ETH_ALEN*2], skb->data-2, 2); // type
				DEBUGP("FAST-L2TP: call-reply, dev->name=%s\n", skb->dev->name);
				state = L2TP_REPLY_RECEIVED;
	  		}
	    	}
			
          	if(MessageType==connect_control && *(p_id+1)!= 0)
	  	{
			/*log ip/session id information when from protocal stack, not from br0*/
			if(state < L2TP_CONNECTED)
			{
		    		l2tpInfo.tid=*p_id;
		    		l2tpInfo.cid=*(p_id+1);
	      	    		l2tpInfo.saddr = skb->nh.iph->saddr;
	      	    		l2tpInfo.daddr = skb->nh.iph->daddr;
#ifdef DOS_FILTER
				extern void filter_addconnect(__u32 ipaddr);
				 filter_addconnect(l2tpInfo.daddr);
#endif
				l2tpInfo.valid = 1;
				rtl865x_setNetifType("ppp0", IF_L2TP);
				DEBUGP("FAST-L2TP: connected\n");
				state = L2TP_CONNECTED;
			}
	    	}
	  }
	return;		
}

void fast_l2tp_rx(struct sk_buff *skb)
{
	struct iphdr *iph=skb->nh.iph;
	struct udphdr *hdr= (struct udphdr *)(((unsigned char *)iph) + iph->ihl*4);
	
	if(skb->len < 40)
		return;

	if (hdr->source==1701 && hdr->dest==1701) {
		if (l2tpInfo.wan_dev == NULL) 
			l2tp_tx_id(skb);
		
		if (l2tpInfo.tid!=0 && l2tpInfo.cid!=0 && skb->data[38]==0 && skb->data[39]==0x21 &&
			l2tpInfo.wan_dev && l2tpInfo.saddr==skb->nh.iph->daddr &&
				l2tpInfo.daddr== skb->nh.iph->saddr) {  	
#if 0				
	      		memcpy(&l2tpInfo.mac_header[0], skb->data-ETH_HLEN+ETH_ALEN, ETH_ALEN); // da of tx pkt
			memcpy(&l2tpInfo.mac_header[ETH_ALEN], skb->data-ETH_HLEN, ETH_ALEN); // sa of tx pkt
			memcpy(&l2tpInfo.mac_header[ETH_ALEN*2], skb->data-2, 2); // type
#endif
			if (l2tpInfo.ppp0_dev == NULL)
			{
				l2tpInfo.ppp0_dev =__dev_get_by_name("ppp0");
			}

			if (l2tpInfo.ppp0_dev) {
				if (((struct iphdr *)(&skb->data[40]))->protocol == IPPROTO_TCP ||
					((struct iphdr *)(&skb->data[40]))->protocol == IPPROTO_UDP) {				
					skb->dev = l2tpInfo.ppp0_dev;
					skb_pull(skb,40);
					skb->h.raw = skb->nh.raw = skb->data;
					DEBUGP("FAST-L2TP: delete l2tp header!\n");			
				}
			}
		}
	  }
}

unsigned long get_fast_l2tp_lastxmit(void)
{
	if(l2tpInfo.valid == 1)
		return l2tpInfo.last_xmit;
	return 0;
}

int fast_l2tp_to_wan(struct sk_buff *skb)
{	
	int	header_len;
	struct iphdr *iph,*iph_new, iph_newone;
	struct l2tp_ext_hdr	*l2tph, l2tphone;
	unsigned char tos;
	unsigned short frag_off;

	if(!fast_l2tp_fw || l2tpInfo.tid==0 || l2tpInfo.cid==0 || !l2tpInfo.wan_dev)
		return 0;

	if(l2tpInfo.valid != 1)
		return 0;
	
	iph = skb->nh.iph;
	__u16 old_len = ntohs(iph->tot_len); 
	header_len = ETH_HLEN + sizeof(struct iphdr) +18 ;
	if (skb_headroom(skb) < header_len || skb_cloned(skb) || skb_shared(skb)) 
	{
		struct sk_buff *new_skb = skb_realloc_headroom(skb, header_len);				
		if (!new_skb) {
			printk("%s: skb_realloc_headroom failed!\n", __FUNCTION__);
			return 0;
		}
		dev_kfree_skb(skb);
		skb = new_skb;
	}
	tos = skb->nh.iph->tos;
	frag_off = skb->nh.iph->frag_off;

	// build mac header
	memcpy(skb_push(skb, header_len), l2tpInfo.mac_header, ETH_HLEN);

	// build ip header
	iph_new = &iph_newone;
	iph_new->version	=	4;
	iph_new->ihl		=	sizeof(struct iphdr) >> 2;
	iph_new->frag_off	=	frag_off;
	iph_new->protocol	=	IPPROTO_UDP;
	iph_new->tos		=	tos;
    	iph_new->daddr	=	l2tpInfo.daddr;
    	iph_new->saddr	=	l2tpInfo.saddr;
    	iph_new->ttl 		=	IPDEFTTL;
    	skb->ip_summed	=	CHECKSUM_NONE;
    	iph_new->tot_len	=	htons(skb->len - ETH_HLEN);
    	iph_new->id		=	0;

    	iph_new->check	=	0;
    	iph_new->check	=	ip_fast_csum((unsigned char *)iph_new, iph_new->ihl);	
    	memcpy(skb->data + ETH_HLEN, &iph_newone, sizeof(iph_newone));
    	l2tph = &l2tphone;
    	l2tph->source	=1701;
    	l2tph->dest	=1701;
	l2tph->len	=old_len+18;
	l2tph->checksum=0;
	l2tph->type	=0x0002;
	l2tph->tid	=l2tpInfo.tid;
	l2tph->cid	=l2tpInfo.cid;
	l2tph->addr_control= 0xff03;
	l2tph->protocol	=0x0021;
    	memcpy(skb->data+ETH_HLEN+sizeof(struct iphdr), &l2tphone, sizeof(struct l2tp_ext_hdr));

	skb->dev=l2tpInfo.wan_dev;
	DEBUGP("FAST-L2TP: fw to WAN!\n");
	l2tpInfo.last_xmit = jiffies;

#ifdef CONFIG_NET_QOS
	if (gQosEnabled) 
	{
		// call dev_queue_xmit() instead of hard_start_xmit(), because I want the packets be sent through Traffic Control module
		dev_queue_xmit(skb);		
		return 1;	
	}
	else            
#endif
		//dev_hard_start_xmit(skb,skb->dev);
		dev_queue_xmit(skb);
	return 1;
}

#if 0
static int rtl_printkl2tpcache(void)
{
	printk("cid(%d),daddr(0x%x),ppp0_dev->name(%s),l2tpInfo.saddr(0x%x),l2tpInfo.tid(%d),l2tpInfo.wan_dev->name(%s),valid(%d)\n",
		l2tpInfo.cid,l2tpInfo.daddr,l2tpInfo.ppp0_dev->name,l2tpInfo.saddr,l2tpInfo.tid,
		l2tpInfo.wan_dev->name,l2tpInfo.valid);
		return 1;
}
#endif

static int l2tp_read_proc(char *page, char **start, off_t off,
		     int count, int *eof, void *data)
{
      int len;

      len = sprintf(page, "%c\n", fast_l2tp_fw + '0');

      if (len <= off+count) *eof = 1;
      *start = page + off;
      len -= off;
      if (len>count) len = count;
      if (len<0) len = 0;
      return len;
}

static int l2tp_write_proc(struct file *file, const char *buffer,
		      unsigned long count, void *data)
{
      char l2tp_tmp;

      if (count < 2)
	    return -EFAULT;

      if (buffer && !copy_from_user(&l2tp_tmp, buffer, 1)) {
	    	fast_l2tp_fw = l2tp_tmp - '0';
      		if(fast_l2tp_fw==1) {
		      l2tp_tx_id_hook=l2tp_tx_id;
      		}
	      	else
		{
		      l2tp_tx_id_hook=NULL;
		      l2tpInfo.tid=0;
		}
		memset(&l2tpInfo, 0, sizeof(l2tpInfo));
		state = L2TP_INITED;
		return count;
      }
      return -EFAULT;
}


#if defined(CONFIG_PROC_FS)
static struct proc_dir_entry *res1=NULL;
#endif

int __init fast_l2tp_init(void)
{
#if defined(CONFIG_PROC_FS)
	res1 = create_proc_entry("fast_l2tp", 0, NULL);
	if (res1) {
		res1->read_proc = l2tp_read_proc;
		res1->write_proc = l2tp_write_proc;
	}
#endif

	l2tp_tx_id_hook = NULL;
	fast_l2tp_fw = 0;
	state = 0;
	memset(&l2tpInfo, 0, sizeof(l2tpInfo));
	return 0;
}

void __exit fast_l2tp_exit(void)
{
#if defined(CONFIG_PROC_FS)
	if (res1) {
		remove_proc_entry("fast_l2tp", res1);		
		res1 = NULL;
	}
#endif
}
#endif
#if 0
#ifdef CONFIG_FAST_PATH_MODULE
EXPORT_SYMBOL(fast_l2tp_init);
EXPORT_SYMBOL(fast_l2tp_exit);
EXPORT_SYMBOL(l2tp_tx_id);
EXPORT_SYMBOL(fast_l2tp_to_wan);
EXPORT_SYMBOL(fast_l2tp_rx);
EXPORT_SYMBOL(l2tp_tx_id_hook);
EXPORT_SYMBOL(fast_l2tp_fw);
#endif
#endif
