/*
 * @file Member ID Definition of Group Miscellaneous.
 *
 * Moderator: JasonJiang
 * Group ID: 0x00150000/0x80150000
 */

#ifndef _CSID_MISC_H
#define _CSID_MISC_H

#include "csid_gid.h"

#define _CFG_MISC(x)         (CSID_GIDC_MISC|(x))
#define _STA_MISC(x)         (CSID_GIDS_MISC|(x))


#define MISC_PING_STOP	0
#define MISC_PING_START	1


/* Configuration Items */
#define CSID_C_MISC_REMOTE_ADMIN_ENABLE		_CFG_MISC(0x0001)	//T=u8, rule enable, 1:yes 0:no
#define CSID_C_MISC_REMOTE_ADMIN_IP		    _CFG_MISC(0x0002)	//T=ipv4, the ip of administrators
#define CSID_C_MISC_REMOTE_ADMIN_PORT		_CFG_MISC(0x0003)	//T=u16, the port of adminitrators 
#define CSID_C_MISC_REMOTE_ADMIN_NM		    _CFG_MISC(0x0004)	//T=u16, the netmask of adminitrators 

#define CSID_C_MISC_DISCARD_PING			_CFG_MISC(0x0005)	//T=u8, whether discarding ping from wan, 1:yes 0:no
#define CSID_C_MISC_SPI_MODE				_CFG_MISC(0x0006)	//T=u8, whether enabling SPI mode, 1:yes 0:no
#define CSID_C_MISC_DOS_ATTACK				_CFG_MISC(0x0007)	//T=u8, whether protecting DoS attackment, 1:yes 0:no

#define CSID_C_MISC_DMZ_ENABLE				_CFG_MISC(0x0008)	//T=u8, DMZ enable, 1:yes 0:no
#define CSID_C_MISC_DMZ_HOST_IP				_CFG_MISC(0x0009)	//T=ipv4, the ip of DMZ host
#define CSID_C_MISC_NONSTANDARD_FTP_PORT	_CFG_MISC(0x000A)	//T=u16, the port of non-standard FTP port
#define CSID_C_MISC_UPNP_ENABLE				_CFG_MISC(0x000B)	//T=u8, UPnP enable, 1:yes 0:no
#define CSID_C_MISC_IGMP_ENABLE				_CFG_MISC(0x000C)	//T=u8,	 IGMP enable, 1:yes 0:no
#define CSID_C_MISC_QOS_SMALL_PKT_ENABLE	_CFG_MISC(0x000D)	//T=u8,	D=0, QoS for small packets enable, 1:yes 0:no
#define CSID_C_MISC_STEALTH_EABLE	        _CFG_MISC(0x000E)	//T=u8,	D=0, Stealth Mode, 1:yes 0:no
#define CSID_C_MISC_ENABLE_WEBRB	        _CFG_MISC(0x000F)	//T=u8,	D=0, Web Rebinding, 1:yes 0:no

#define CSID_C_MISC_DISABLE_PPTP_ALG        _CFG_MISC(0x0010)   //T=u8,	 Whether to disable PPTP Passthrough, 1:yes 0:no 
#define CSID_C_MISC_DISABLE_L2TP_ALG        _CFG_MISC(0x0011)   //T=u8,	 Whether to disable L2TP Passthrough, 1:yes 0:no 
#define CSID_C_MISC_DISABLE_IPSEC_ALG       _CFG_MISC(0x0012)   //T=u8,	 Whether to disable IPSec Passthrough, 1:yes 0:no 
#define CSID_C_MISC_ENABLE_NAT_LOOPBACK     _CFG_MISC(0x0013)   //T=u8,	 D=0, Whether to enable NAT Loopback, 1:yes 0:no 
#define CSID_C_MISC_DONT_REPLY_CONF_REQ     _CFG_MISC(0x0014)   //T=u8,	 D=0, Whether to response Configure-Request
#define CSID_C_MISC_DISABLE_TELNETD         _CFG_MISC(0x0015)   //T=u8,	 D=0, Whether to start telnetd (Need reboot)
#define CSID_C_MISC_TELNETD_ALLOW_WAN       _CFG_MISC(0x0016)   //T=u8,	 D=0, Whether to allow conect to telnetd from WAN side (Need reboot)
#define CSID_C_MISC_TELNETD_BIND_PORT       _CFG_MISC(0x0017)   //T=u32, D=0, Change the bind port of telnetd (Need reboot)

#define CSID_C_MISC_SYSLOG_ENABLE			_CFG_MISC(0x0020)	//T=u8, enable to send log to collector
#define CSID_C_MISC_SYSLOG_COLLECTOR_IP		_CFG_MISC(0x0021)	//T=ipv4, syslog collector's ip
#define CSID_C_MISC_SYSLOG_COLLECTOR_PORT	_CFG_MISC(0x0022)	//T=u16, syslog collector's port
#define CSID_C_MISC_SYSLOG_TYPE_SYSTEM      _CFG_MISC(0x0023)	//T=u8, enable system activities type of syslog
#define CSID_C_MISC_SYSLOG_TYPE_ATTACKS     _CFG_MISC(0x0024)	//T=u8, enable attacks type of syslog
#define CSID_C_MISC_SYSLOG_TYPE_NOTI_DROP   _CFG_MISC(0x0025)	//T=u8, enable dropped and notices type of syslog
#define CSID_C_MISC_SYSLOG_TYPE_DEBUG       _CFG_MISC(0x0026)	//T=u8, enable debug type of syslog
 
#define CSID_C_MISC_TX_RATE_CONTROL_ENABLE	_CFG_MISC(0x0030)	//T=u8,	 TX Rate Control enable, 1:yes 0:no
#define CSID_C_MISC_TX_NEW_TCP_RATE		    _CFG_MISC(0x0031)	//T=u16, Number of New TCP connections can be created (per seconed)
#define CSID_C_MISC_TX_NEW_UDP_RATE		    _CFG_MISC(0x0032)	//T=u16, Number of New UDP connections can be created (per seconed)
#define CSID_C_MISC_TX_SMALL_UDP_RATE		_CFG_MISC(0x0033)	//T=u16, Number of small size UDP packets can be sent (per seconed)
#define CSID_C_MISC_TX_SMALL_UDP_PKTSZ		_CFG_MISC(0x0034)	//T=u16, Define the length of TX packet is small 

#define CSID_C_MISC_RX_RATE_CONTROL_ENABLE	_CFG_MISC(0x0035)	//T=u8,	 RX Rate Control enable, 1:yes 0:no
#define CSID_C_MISC_RX_NEW_TCP_RATE		    _CFG_MISC(0x0036)	//T=u16, Number of New TCP connections can be accepted (per seconed)
#define CSID_C_MISC_RX_NEW_UDP_RATE		    _CFG_MISC(0x0037)	//T=u16, Number of New UDP connections can be accepted (per seconed)
#define CSID_C_MISC_RX_SMALL_UDP_RATE		_CFG_MISC(0x0038)	//T=u16, Number of small size UDP packets can be received (per seconed)
#define CSID_C_MISC_RX_SMALL_UDP_PKTSZ		_CFG_MISC(0x0039)	//T=u16, Define the length of RX packet is small 
#define CSID_C_MISC_IGMP_SNOOP_ENABLE		_CFG_MISC(0x003A)	//T=u8,	 IGMP Snoop enable, 1:yes 0:no  
#define CSID_C_MISC_IGMP_QUICKLEAVE			_CFG_MISC(0x003B)	//T=u8,	 IGMP quick leave enable, 1:yes 0:no 
#define CSID_C_MISC_ENABLE_STP			    _CFG_MISC(0x003C)	//T=u8,	 Enable/Disable Spanning Tree, 1:yes 0:no 

// Remote admin support more rules
#define CSID_C_MISC_REMOTE_ADMIN_ENABLE_2	_CFG_MISC(0x0040)	//T=u8, rule enable, 1:yes 0:no
#define CSID_C_MISC_REMOTE_ADMIN_IP_2		_CFG_MISC(0x0050)	//T=ipv4, the ip of administrators
#define CSID_C_MISC_REMOTE_ADMIN_PORT_2		_CFG_MISC(0x0060)	//T=u16, the port of adminitrators 
#define CSID_C_MISC_REMOTE_ADMIN_NM_2		_CFG_MISC(0x0070)	//T=u16, the netmask of adminitrators 
  
#define CSID_C_MISC_PING_TARGET				_CFG_MISC(0x0080)	//T=str, default target for ping test
#define CSID_C_MISC_WAKE_TARGET				_CFG_MISC(0x0081)	//T=mac, default target for wake on lan
#define CSID_C_MISC_MAX_LOW_BATTERY			_CFG_MISC(0x0082)	//T=u8,  Max number of Low Battery/Power
#define CSID_C_MISC_BTY_DETECT_INTERVAL		_CFG_MISC(0x0083)	//T=u8,  Detect Interval of  Low Battery/Power
#define CSID_C_MISC_M1LED_ALWAYS_ON			_CFG_MISC(0x0084)	//T=u8,  M1 Status LED, 0: twinkling 1:always on
#define CSID_C_MISC_DIM_LED					_CFG_MISC(0x0085)	//T=u8,  DIM LED, 0:brighten led, 1:dim led
#define CSID_C_MISC_DIM_RULE_NO				_CFG_MISC(0x0086)	//T=u16, D=0, rule number for scheduling dimming leds
#define CSID_C_MISC_PWR_SAVING_ENABLE       _CFG_MISC(0x0087)   //T=u8, D=0, power saving enable
#define CSID_C_MISC_WIFI_PWR_SAVING         _CFG_MISC(0x0088)   //T=u8, D=0, wifi power saving
#define CSID_C_MISC_HSPA_PWR_SAVING         _CFG_MISC(0x0089)   //T=u8, D=0, hspa power saving
#define CSID_C_MISC_CPU_PWR_SAVING          _CFG_MISC(0x008A)   //T=u8, D=0, cpu power saving
#define CSID_C_MISC_LOGIN_PROMPT            _CFG_MISC(0x008B)	//T=str, default login prompt for customization login RT305XL:


#define CSID_C_MISC_DLNA_ENABLE          _CFG_MISC(0x008C)   //T=u8, D=1, DLNA Enable/Disable

#define CSID_C_MISC_PROVISIONING_SERVER     _CFG_MISC(0x008D)   //T=str, covia provisioning server
#define CSID_C_MISC_CENTRAL_SERVER          _CFG_MISC(0x008E)   //T=str, covia central server
#define CSID_C_MISC_NTP_SERVER_PRI          _CFG_MISC(0x008F)   //T=ipv4, covia ntp provisioning server primary
#define CSID_C_MISC_NTP_SERVER_SEC          _CFG_MISC(0x0090)   //T=ipv4, covia ntp server secondary
#define CSID_C_MISC_FIRMWARE_SERVER         _CFG_MISC(0x0091)   //T=str, covia firmware server
#define CSID_C_MISC_UPNP_SETTINGS           _CFG_MISC(0x0092)   //T=u8, covia upnp settings
#define CSID_C_MISC_UPNP_PUBLIC_ADDRESS     _CFG_MISC(0x0093)   //T=ipv4, covia upnp public ip address
#define CSID_C_MISC_UPNP_PUBLIC_PORT        _CFG_MISC(0x0094)   //T=u32, covia upnp public port number
#define CSID_C_MISC_DLNA_AUTO_RESCAN          _CFG_MISC(0x0095)   //T=u8, D=1, DLNA auto rescan Enable/Disable

#define CSID_C_MISC_HANDLE_MEM_DISABLE         _CFG_MISC(0x00a0)   //T=u8, D=0, commander handle_memory disable, 0: enable 1: disable
#define CSID_C_MISC_MULTIWAN_DMZ_MODE		_CFG_MISC(0x00a1)	//T=u8, D=0, DMZ mode, 1:MULTI mode 0:single mode

#define CSID_C_MISC_MULTIWAN_DMZ_ENABLE		_CFG_MISC(0x00b0)	//T=u8, D=0, DMZ enable, 1:yes 0:no
/*reserve 16 space for multiwan*/
#define CSID_C_MISC_MULTIWAN_DMZ_HOST_IP	_CFG_MISC(0x00c0)	//T=ipv4, the ip of DMZ host
/*reserve 16 space for multiwan*/

/* Status Items */
#define CSID_S_MISC_ALTERED					_STA_MISC(0x0002)	//T=u8, ui altered
#define CSID_S_MISC_PING_PID				_STA_MISC(0x0003)	//T=u32, the pid of ping
#define CSID_S_MISC_PING_STATUS				_STA_MISC(0x0004) 	//T=u32, the status of ping 
#define CSID_S_MISC_PING_TARGET_TMP			_STA_MISC(0x0005)	//T=str, default target for ping test

#define CSID_S_MISC_UPNP_CHK				_STA_MISC(0x0006)	//T=u32, default ,upnp_chk 1 cannot run start or upnp_chk 2 cannot run stop
#define CSID_S_MISC_WEBRB_ALTERED			_STA_MISC(0x0007)	//T=u8, ui altered
#define CSID_S_MISC_WEBRB_ISSUEID			_STA_MISC(0x0008)	//T=u8, issue ID recorded 
#define CSID_S_MISC_DLNA_STATUS				_STA_MISC(0x0009)	//T=u8, D=0, DLNA 0:Off , 1: On
#define CSID_S_MISC_DLNA_RESCAN				_STA_MISC(0x000A)	//T=u8, D=0, DLNA 1: Rescan all files
#define CSID_S_MISC_RESTART				_STA_MISC(0x000B)	//T=u8, D=0, restart commander
#define CSID_S_MISC_INTERNET_BREAK                      _STA_MISC(0x000C)	//T=u8, internet break for manual
#endif //ifndef _CSID_MISC_H
